/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H 
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <bfd.h>                      /* Callbacks from GTK are caught here*/
#include <stdlib.h>

#include "main.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "config.h"
#include "chump.h"
#include "dotparse.h"

char *chump_string =                   // This is very dirty
#include "chump.string"
;



void disassamblefile(char* arch,char* filename)
{
 bfd *abfd;
 asection *section;
 long storage_needed;
 long i;
 GList* list = NULL;
 asymbol **bfd_symbol_table;
 symbol *symbol_table=NULL;
 int symbol_count=0;
 
 GList* toplist;
 GList* cpulist;
 GScanner *scanner;
 PtrSCANNode Scantopnode;
 DefinitionStack* isa_list;

 bfd_init ();            			/* init BFD (exectuable file loader) */
 
 if (chump_filename){
    scanner = ScanOpenSCANFile (chump_filename);              // open file
    g_print("Loading:%s\n",chump_filename);
    }
    
 else {
    scanner = ScanOpenSCANString (chump_string);
    g_print("Loading internal chump file\n");
    }

 
  if (!scanner) return;
  Scantopnode = ScanParseSCANNode (scanner, FALSE);   // parse it
  toplist=Scantopnode->body.list;                     // Get top level node
  cpulist=Scantopnode->body.list;                     // Get top level node
  
  while((cpulist = ScanfindSymbolList    (toplist,"isa",NULL))){
        if (!g_strcasecmp(SCAN_SYMBOL(SCAN_LIST_FIRST(cpulist)),arch))
            asm_tables = asm_define(cpulist, asm_tables, SCAN_SYMBOL(SCAN_LIST_FIRST(cpulist)));      // Parse the desciption
        toplist = ScanfindSymbolListNext(toplist,"isa",NULL);       // Move on
    }
  
  isa_list = asm_tables;                    //Walk though the ISAs

 
 
 
 
 
 bfd_set_error (bfd_error_no_error);
 abfd = bfd_openr (filename, NULL); 
 g_print("Loading: %s\n",filename);
 if (bfd_get_error ()) {g_print("ELF load error:%s\n",bfd_errmsg (bfd_get_error())); return;}
 if (!bfd_check_format(abfd, bfd_object)) {g_print("File is not BFD format");bfd_close(abfd); return;} /* on any error just return */
// if(bfd_get_error()){g_print("%s\n",bfd_errmsg (bfd_get_error()));}
 bfd_set_error (bfd_error_no_error);
 
 storage_needed = bfd_get_symtab_upper_bound (abfd);
 if (storage_needed < 0) {g_print("ELF load error in symbol table load\n"); return;}
 if (storage_needed != 0) {
    if (symbol_table){
        while(symbol_count--) g_free(symbol_table[symbol_count].name);
        g_free(symbol_table);
        }
    bfd_symbol_table = (asymbol **) g_malloc (storage_needed);
    symbol_count = bfd_canonicalize_symtab (abfd, bfd_symbol_table);
    symbol_table = g_new(symbol, symbol_count);
    if (symbol_count < 0) {g_print("ELF load error in symbol table load\n"); bfd_close(abfd); return;}
    
    g_print("symbol: address    flags  name\n");

    for (i = 0; i < symbol_count; i++) {
        symbol_table[i].flags=bfd_symbol_table[i]->flags;                           // walk through symbols
        symbol_table[i].name=g_strdup(bfd_symbol_table[i]->name);
        symbol_table[i].value=bfd_symbol_table[i]->value + bfd_symbol_table[i]->section->vma; //add the value to the offset of the section
        g_print("symbol:%8x %8x %s\n",symbol_table[i].value, symbol_table[i].flags, symbol_table[i].name);
        }
    g_free(bfd_symbol_table);
    }
 
 
 section=abfd->sections;
 while(section){
  if (section->flags & 1){                      // is section loadable
     uchar *sectionContents;
     size_t sectionSize = section->_cooked_size; 
     size_t count=0;
     size_t count2=0;
     int sym_count;
     long long start  = section->vma;
     int temp;
     g_print("\nSection start:%d\n",start);
     list = NULL;
     sectionContents = g_new (uchar, sectionSize);
     bfd_get_section_contents (abfd, section, (PTR) sectionContents, 0, sectionSize);
     if(bfd_get_error ()) {g_print("ELF loads error5\n");bfd_close(abfd); return;}
     
     while (count <= sectionSize){              // walk through section
       Disasm disasm;

       disasm = asm_disassemble(list, isa_list->rules, start+count2);   // try to disassamble
       if (disasm.distext == &dis_error ){                              // if error on dissasembly
            if ((g_list_length(list) >  800) || ((count == sectionSize) && list)){      // if there is a very large buffer allready
               list = g_list_nth(list,8);
               g_print("STUCK!!! Trying skipping one character '%02X'\n", sectionContents[count2++]);  // remove a byte from buffer
               }
               
            else {                                                                                      // else add a character
                list = g_list_concat(list,uchararr2glist(1,sectionContents+count));
                count++;
                }
            }
       else {
       
            if (symbol_table){
                sym_count=symbol_count;
                while(sym_count--)
                    if (start+count2 == symbol_table[sym_count].value)  // if no error then print out all lables at line
                        g_print("%s:\n",symbol_table[sym_count].name);
                }
            g_print("    %08X     ", count2+ start);                    // print address  (Stuck at 32 bit) fix if you want something else
            temp=g_list_position(list,disasm.bitfield)>>3;
            if (temp < 0)
                while (count2<count)
                    g_print("%02X", sectionContents[count2++]);         // if got to end of buffer then print out all characters 
            else
                while (temp--)
                    g_print("%02X", sectionContents[count2++]);         // else print out all characters to end of instruction
            
            
            g_print("%s\n",asm_sprint(disasm.distext, g_strdup("     ")));  // print out disassembly
            asm_freestringlist (disasm.distext);                            // free string
                list= disasm.bitfield;                                      // move buffer forwards
            }
	   }
    if (symbol_table){                                                      // printout end of section symbols
        sym_count=symbol_count;
        while(sym_count--)
            if (start+count2 == symbol_table[sym_count].value)
                    g_print("%s:\n",symbol_table[sym_count].name);
        }
     g_free(sectionContents);
     }
     section=section->next;
  }
  
   bfd_close(abfd);
      
 return;
}




void commandline(int argc, char *argv[])
{
 int count=1;
 int create=0;
 FILE* fd;
 int comp;
 char* gtkrc[] = {NULL,NULL};
 char* commandstrings[]={"--help", "-h", "-?", "-l", "-d", "-c", "-t", NULL};
            //             0         1     2     3     4     5     6    7
 
 while (argv[count]){
   if ('-' != *argv[count]) {g_print("Unknown option %s\n",argv[count]);exit(1);}
   comp=0;
   while (g_strcasecmp(commandstrings[comp],argv[count]))
        if (!commandstrings[comp]) {g_print("Unknown option  %s\n",argv[count]);exit(1);}
        else comp++;
   switch (comp) {
    case 0:
    case 1:
    case 2:         //help
        g_print("\n " PACKAGE " Version " VERSION " (06/07/2002)\n");
        g_print(" Author:Charlie Brej\n");
        g_print(" Bug reports and feature requests: chump@cs.man.ac.uk\n");
        g_print(" Website: http://www.cs.man.ac.uk/~brejc8/chump_project.html\n");
        g_print("\n");
        g_print(" Usage: chump [options]\n");
        g_print("\n");
        g_print("   --help\n");
        g_print("   -h\n");
        g_print("   -?              display this help message\n");
        g_print("   -l file         choose initial .chump file \n");
        g_print("   -d ARCH file    disassamble file using ARCH acrhitecture description\n");
        g_print("   -c file         create the default chump file \n");
        g_print("   -t gtkrc        change GTK+ theme by specifying a different gtkrc file\n");
        exit(0);
    case 3:         //load
        if (!argv[count+1]) {g_print("No Architecture or filename specified!\n");exit(1);}
        chump_filename= argv[++count];
        break;
    case 4:         //Disassamble
        if (!argv[count+1]) {g_print("No Architecture or filename specified!\n");exit(1);}
        if (!argv[count+2]) {g_print("No filename specified!\n");exit(1);}
        disassamblefile(argv[count+1], argv[count+2]);
        exit(0);
    case 5:         //Create .chump file -c
        create = 1;
        if (!argv[count++]) {g_print("No filename specified!\n");exit(1);}
        fd = fopen (argv[count],"w");
        if (!fd) {g_print("cant open %s file\n",argv[count]); exit(1);}
        fprintf(fd, "%s", chump_string);
        fclose(fd);
        g_print("Done\n");
        exit(0);
    case 6:         //Theme -t
        if (argv[count+1]) if ('-' != *argv[count+1]){
                                gtkrc[0]=argv[++count];
                                gtk_rc_set_default_files(gtkrc);
                                }
        break;
    default:
        g_print("Command paramiter Error!");
        exit(1);
    }
   count++;
   }
}

int
main (int argc, char *argv[])
{
  chump_filename=NULL;
  commandline(argc, argv);
  gtk_init (&argc, &argv);

  address=0;
  about_window = create_about_window ();
  gtk_label_set_text(GTK_LABEL(gtk_object_get_data(GTK_OBJECT(about_window),"info_label")),
        "Chump v" VERSION "\nCharlie Brej\nhttp://www.cs.man.ac.uk/~brejc8\nBug reports and feature requests\nchump@cs.man.ac.uk");
  fileselection = create_fileselection();
  main_window = create_main_window ();
  on_reload_clicked(NULL,NULL);
  gtk_widget_show (main_window);
  gtk_main ();
  return 0;
}

